package ru.landgrafhomyak.utility.highlevel_try_finally

fun <R> safeAutoClose(
	onError: () -> Unit = {},
	onSuccess: () -> Unit = {},
	action: () -> R
): R {
	val ret: R
	var wasError = false
	var crossReturned = true
	try {
		ret = action()
		crossReturned = false
	} catch (e1: Throwable) {
		wasError = true
		try {
			onError()
		} catch (e2: Throwable) {
			e1.addSuppressed(e2)
		}
		throw e1
	} finally {
		if (!wasError) {
			if (crossReturned)
				throw Error("crossreturn")
			onSuccess()
		}
	}
	return ret
}
